//+------------------------------------------------------------------+
//|                                                  .mq4 |
//|                                                            Shuba |
//|                                              subinandrei@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Shuba"
#property link      "subinandrei@mail.ru"

extern int ZZper = 3;
extern string prefix = "vibr_"; //    
double ZZ0UP, ZZ1UP, ZZ2UP, ZZ0DW, ZZ1DW, ZZ2DW;
int ZZ0upB, ZZ1upB, ZZ2upB, ZZ0dwB, ZZ1dwB, ZZ2dwB;
double t1,t2,t3;
int P, B, Real;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment ("");
  for(int i = ObjectsTotal()-1; i >= 0; i--)  //     
      if(StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)//  ..
                                                   // ..  ,  
                                                   // ..prefix, ..
        ObjectDelete(ObjectName(i));           // ..   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
//----
  ZZ();
  Per ();
//----
   if(ZZ0upB < ZZ0dwB) 
     {
     SetTLine(GreenYellow, prefix + "1",Time[ZZ2upB], High[ZZ2upB], Time[ZZ0dwB], Low[ZZ0dwB]);
     SetTLine(GreenYellow, prefix + "2", Time[ZZ1dwB], Low[ZZ1dwB], Time[ZZ1upB], High[ZZ1upB]); 
     
     SetVLine(OrangeRed, prefix + "T1", GetTimeByBarShift(Period(), ZZ0dwB - B));
     SetVLine(OrangeRed, prefix + "T2", GetTimeByBarShift(Period(), ZZ0dwB - B*2));
     SetVLine(OrangeRed, prefix + "T3", GetTimeByBarShift(Period(), ZZ0dwB - B*3));
     SetVLine(OrangeRed, prefix + "T4", GetTimeByBarShift(Period(), ZZ0dwB - B*4));
     SetVLine(OrangeRed, prefix + "T5", GetTimeByBarShift(Period(), ZZ0dwB - B*5));
     SetVLine(OrangeRed, prefix + "T6", GetTimeByBarShift(Period(), ZZ0dwB - B*6));
     }
   if(ZZ0dwB < ZZ0upB) 
     {
     SetTLine(GreenYellow, prefix + "1", Time[ZZ2dwB], Low[ZZ2dwB], Time[ZZ0upB], High[ZZ0upB]);
     SetTLine(GreenYellow, prefix + "2", Time[ZZ1dwB], Low[ZZ1dwB], Time[ZZ1upB], High[ZZ1upB]); 
     
     SetVLine(DarkTurquoise, prefix + "T1", GetTimeByBarShift(Period(), ZZ0upB - B));
     SetVLine(DarkTurquoise, prefix + "T2", GetTimeByBarShift(Period(), ZZ0upB - B*2));
     SetVLine(DarkTurquoise, prefix + "T3", GetTimeByBarShift(Period(), ZZ0upB - B*3));
     SetVLine(DarkTurquoise, prefix + "T4", GetTimeByBarShift(Period(), ZZ0upB - B*4));
     SetVLine(DarkTurquoise, prefix + "T5", GetTimeByBarShift(Period(), ZZ0upB - B*5));
     SetVLine(DarkTurquoise, prefix + "T6", GetTimeByBarShift(Period(), ZZ0upB - B*6));
     }
   
   
   /*Comment(" 0 = ",ZZ0UP,"   ", ZZ0upB, "\n",
          " 1 = ",ZZ1UP,"   ", ZZ1upB, "\n",
          " 2 = ",ZZ2UP,"   ", ZZ2upB, "\n", "\n",  
          " 0 = ",ZZ0DW,"   ", ZZ0dwB, "\n",
          " 1 = ",ZZ1DW,"   ", ZZ1dwB, "\n",
          " 2 = ",ZZ2DW,"   ", ZZ2dwB);*/
          
  //Comment(" = ", Middle());
  string Text_1 = "  = ";
  string Text_2 = "  = ";
  string Text_3 = "   = ";
  string Text_4 = "  = ";
  //SetHLine(Red, "3", Middle()); 

//----    ---------------------------------------------+     
  SetLabel(prefix + "Label1", Text_1 + Middle(), MistyRose, 5, 40);
  SetLabel(prefix + "Label2", Text_2 + P, Honeydew, 5, 60);
  SetLabel(prefix + "Label3", Text_3 + B, LightCyan, 5, 80);
  SetLabel(prefix + "Label4", Text_4 + Real, LightCyan, 5, 100);
//----  
  //Comment(t1,"  ",t2,"  ",t3);   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
datetime GetTimeByBarShift(int period, int shift ) //     
  {
  //Comment(timeB,"  ",ZZ1dwB,"  ",shift);
  if(shift >= 0)
        return(iTime(NULL, period, shift));
    else
        return(iTime(NULL, period, 0) - shift*period*60);
  }
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 02.07.2008                                                     |
//|   :   OBJ_VLINE                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                ("" -    )     |
//|    t1 -                       (0  -    )     |
//|    st -                  (0  -  )                    |
//|    wd -                 (1  -  )                     |
//+----------------------------------------------------------------------------+
void SetVLine(color cl, string nm="", datetime t1=0, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[0];
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_VLINE, 0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1, t1);
  ObjectSet(nm, OBJPROP_COLOR, cl);
  ObjectSet(nm, OBJPROP_STYLE, st);
  ObjectSet(nm, OBJPROP_WIDTH, wd);
} 
//+----------------------------------------------------------------------------+

//+------------------------------------------------------------------+
void Per()
  {
  
  if(ZZ0upB < ZZ0dwB) 
    {
    t1 = NormalizeDouble(High[ZZ1upB],4)*10000;
    t2 = NormalizeDouble(Middle(),4)*10000;
    t3 = NormalizeDouble(Low[ZZ1dwB],4)*10000;
    int Razn = ZZ2upB - ZZ0dwB;
    Real = ZZ0dwB - ZZ0upB;
    }
  if(ZZ0dwB < ZZ0upB) 
    {
    t1 = NormalizeDouble(High[ZZ1upB],4)*10000;
    t2 = NormalizeDouble(Middle(),4)*10000;
    t3 = NormalizeDouble(Low[ZZ1dwB],4)*10000;
    Razn = ZZ2dwB - ZZ0upB;
    Real = ZZ0upB - ZZ0dwB;
    }
  
  P = MathRound((t1 - t2)/((t1 - t3)/100));
  B = MathRound(MathSqrt(Razn * 100 / P));
  //Comment(Razn, "   ", MathRound(Razn * 100 / P));
  return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
double Middle()
  {
  double x[4], y[4], t[2];
  double M;
  int    i, k=ObjectsTotal(), ot;
  string on;

  ArrayInitialize(x, 0.0);
  ArrayInitialize(y, 0.0);

  for (i=0; i<k; i++) {
    on=ObjectName(i);
    ot=ObjectType(on);
    switch (ot) {
      case OBJ_VLINE:
        if (x[0]==0) {
          x[0]=ObjectGet(on, OBJPROP_TIME1);
          x[1]=ObjectGet(on, OBJPROP_TIME1);
          y[0]=WindowPriceMin();
          y[1]=WindowPriceMax();
        } else {
          if (x[2]==0) {
            x[2]=ObjectGet(on, OBJPROP_TIME1);
            x[3]=ObjectGet(on, OBJPROP_TIME1);
            y[2]=WindowPriceMin();
            y[3]=WindowPriceMax();
          }
        }
        break;
      case OBJ_HLINE:
        if (x[0]==0) {
          x[0]=Time[WindowFirstVisibleBar()];
          x[1]=Time[0];
          y[0]=ObjectGet(on, OBJPROP_PRICE1);
          y[1]=ObjectGet(on, OBJPROP_PRICE1);
        } else {
          if (x[2]==0) {
            x[2]=Time[WindowFirstVisibleBar()];
            x[3]=Time[0];
            y[2]=ObjectGet(on, OBJPROP_PRICE1);
            y[3]=ObjectGet(on, OBJPROP_PRICE1);
          }
        }
        break;
      case OBJ_TREND:
        if (x[0]==0) {
          x[0]=ObjectGet(on, OBJPROP_TIME1);
          x[1]=ObjectGet(on, OBJPROP_TIME2);
          y[0]=ObjectGet(on, OBJPROP_PRICE1);
          y[1]=ObjectGet(on, OBJPROP_PRICE2);
        } else {
          if (x[2]==0) {
            x[2]=ObjectGet(on, OBJPROP_TIME1);
            x[3]=ObjectGet(on, OBJPROP_TIME2);
            y[2]=ObjectGet(on, OBJPROP_PRICE1);
            y[3]=ObjectGet(on, OBJPROP_PRICE2);
          }
        }
        break;
    }
  }
  if (x[0]==0 || x[1]==0 || x[2]==0 || x[3]==0
  ||  y[0]==0 || y[1]==0 || y[2]==0 || y[3]==0)
    Comment("   !");
  else CrossPointOfLines(x, y, t);
  if (t[0]==0 || t[1]==0) Comment("    !");
  else M = t[1];
  //SetArrow(5, Red, "", t[0], t[1], 2);
  return(M);
  }
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :      .            |
//|                   .            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    x -                x[0], x[1] -                |
//|                                    x[2], x[3] -                |
//|    y -                y[0], y[1] -                |
//|                                    y[0], y[1] -                |
//|    t -       t[0]       -                    |
//|                                    t[1]       -                    |
//+----------------------------------------------------------------------------+
void CrossPointOfLines(double& x[], double& y[], double& t[]) {
  double z=(y[3]-y[2])*(x[1]-x[0])-(y[1]-y[0])*(x[3]-x[2]);
  ArrayResize(t, 2);
  ArrayInitialize(t, 0.0);

  if (z==0) Print("CrossPointOfLines():     !");
  else {
    double xy1=x[1]*y[0]-x[0]*y[1];
    double xy2=x[3]*y[2]-x[2]*y[3];
    t[0]=NormalizeDouble((xy1*(x[3]-x[2])-xy2*(x[1]-x[0]))/z, 0);
    t[1]=(xy1*(y[3]-y[2])-xy2*(y[1]-y[0]))/z;
  }
}

//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                  |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}


//+----------------------------------------------------------------------------+
void ZZ()
  {
//----  
  ZZ0UP = NormalizeDouble(GetExtremumZZPrice(0, 0),Digits);
  ZZ0upB = GetExtremumZZBar(0, 0);
  
  ZZ1UP = NormalizeDouble(GetExtremumZZPrice(0, 1),Digits);
  ZZ1upB = GetExtremumZZBar(0, 1);
  
  ZZ2UP = NormalizeDouble(GetExtremumZZPrice(0, 2),Digits);
  ZZ2upB = GetExtremumZZBar(0, 2);
//----  
  ZZ0DW = NormalizeDouble(GetExtremumZZPrice(1, 0),Digits);
  ZZ0dwB = GetExtremumZZBar(1, 0);
  
  ZZ1DW = NormalizeDouble(GetExtremumZZPrice(1, 1),Digits);
  ZZ1dwB = GetExtremumZZBar(1, 1);
  
  ZZ2DW = NormalizeDouble(GetExtremumZZPrice(1, 2),Digits);
  ZZ2dwB = GetExtremumZZBar(1, 2);
//----
  }
//+------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :        .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    ma_period -                                                     |
//|    ne -             (      0     - )               |
//+----------------------------------------------------------------------------+
int GetExtremumZZBar(int pic, int ne=0) {
  
  double zz;
  int    i, k=iBars(NULL, 0), ke=0;

  for (i=0; i<k; i++) {
    zz=iCustom(NULL,0,"rvmGann_sv8", ZZper, pic, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(i);
    }
  }
  Print("GetExtremumZZBar():    ",ne,"  ");
  return(-1);
}

//+-------------------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :      .                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    ma_period -                                                     |
//|    ne -             (      0     - )               |
//+----------------------------------------------------------------------------+
double GetExtremumZZPrice(int pic, int ne=0) {
  
  double zz;
  int    i, k=iBars(NULL, 0), ke=0;

  for (i=1; i<k; i++) {
    zz=iCustom(NULL,0,"rvmGann_sv8",  ZZper, pic, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(zz);
    }
  }
  Print("GetExtremumZZPrice():    ",ne,"  ");
  return(0);
}
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 30.03.2008                                                     |
//|   :   OBJ_HLINE                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                ("" -    )     |
//|    p1 -              (0  - Bid)                              |
//|    st -                  (0  -  )                    |
//|    wd -                 (0  -  )                     |
//+----------------------------------------------------------------------------+
void SetHLine(color cl, string nm="", double p1=0, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (p1<=0) p1=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_HLINE, 0, 0,0);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   ,  OBJ_LABEL.                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm -                                                 |
//|    tx -                                                               |
//|    cl -                                                           |
//|    xd -  X                                              |
//|    yd -  Y                                              |
//|    cr -           (0 -  ,                     |
//|                                     1 -  ,                    |
//|                                     2 -  ,                      |
//|                                     3 -   )                    |
//|    fs -                (12 -    )                    |
//+----------------------------------------------------------------------------+
void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=12) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx, fs);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
}
//+----------------------------------------------------------------------------+